Attribute VB_Name = "modImageKit"
Option Explicit
Public Sub LoadFile(ByVal sFileName As String, ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkFile As IkFile)
10:  Dim ret As Boolean
20:  On Error GoTo Error_Handler
30:  If sFileName = vbNullString Then Exit Sub
40:  If oIkDisp.ImgHandle <> 0 Then
50:    oIkCommon.ImgHandle = oIkDisp.ImgHandle
60:    oIkCommon.FreeMemory
70:    oIkDisp.ImgHandle = 0
80:  End If
90:  oIkFile.FileName = sFileName
100:  On Error GoTo Error_Load_File
110:  oIkFile.LoadFile (ikLoad)
120:  On Error GoTo Error_Handler
130:  oIkCommon.ImgHandle = oIkFile.ImgHandle
140:  ret = oIkCommon.GetImageType()
150:  If ret = False Then Exit Sub
160:  If oIkCommon.ImageKind <> ikRasterImage Then
170:    oIkCommon.FreeMemory
180:    oIkDisp.ImgHandle = 0
190:    Exit Sub
200:  End If
210:  oIkDisp.ImgHandle = oIkFile.ImgHandle 'Pass the image handle to the display control
220:  oIkDisp.Display (ikScale)             'Display the image
230:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:LoadFile", Erl
240:  Resume Next
Error_Load_File:
250:  MsgBox "Error loading image file '" & oIkFile.FileName & "'.", vbCritical, sAppName
End Sub
Public Sub LoadImage(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkFile As IkFile)
260:  Dim ret As Boolean
270:  On Error GoTo Error_Handler
  If oIkFile.OpenFileDlg = False Then Exit Sub 'Display the Open File dialog to select an image
280:  If oIkDisp.ImgHandle <> 0 Then
290:    oIkCommon.ImgHandle = oIkDisp.ImgHandle
300:    oIkCommon.FreeMemory
310:    oIkDisp.ImgHandle = 0
320:  End If
330:  oIkFile.LoadFile (ikLoad)
340:  oIkCommon.ImgHandle = oIkFile.ImgHandle
350:  ret = oIkCommon.GetImageType()
360:  If ret = False Then Exit Sub
370:  If oIkCommon.ImageKind <> ikRasterImage Then
380:    oIkCommon.FreeMemory
390:    oIkDisp.ImgHandle = 0
400:    Exit Sub
410:  End If
420:  oIkDisp.ImgHandle = oIkFile.ImgHandle 'Pass the image handle to the display control
430:  oIkDisp.Display (ikScale)             'Display the image
440:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:LoadImage", Erl
450:  Resume Next
End Sub
Public Sub ReloadImage(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkFile As IkFile)
460:  Dim ret As Boolean
470:  On Error GoTo Error_Handler
480:  If oIkDisp.ImgHandle <> 0 Then
490:    oIkCommon.ImgHandle = oIkDisp.ImgHandle
500:    oIkCommon.FreeMemory
510:    oIkDisp.ImgHandle = 0
520:  Else
530:    Exit Sub
540:  End If
550:  oIkFile.LoadFile (ikLoad)
560:  oIkCommon.ImgHandle = oIkFile.ImgHandle
570:  ret = oIkCommon.GetImageType()
580:  If ret = False Then Exit Sub
590:  If oIkCommon.ImageKind <> ikRasterImage Then
600:    oIkCommon.FreeMemory
610:    oIkDisp.ImgHandle = 0
620:    Exit Sub
630:  End If
640:  oIkDisp.ImgHandle = oIkFile.ImgHandle 'Pass the image handle to the display control
650:  oIkDisp.Display (ikScale)             'Display the image
660:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:ReloadImage", Erl
670:  Resume Next
End Sub
Public Sub SetBrightness(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkEffect As IkEffect, ByVal iBrightness As Integer)
680:  Dim ret As Boolean
690:  On Error GoTo Error_Handler
700:  oIkEffect.SelectMode = 1
710:  oIkEffect.InImgHandle = oIkDisp.ImgHandle
720:  ret = oIkEffect.RGBLevel(0, 0, 0, iBrightness, iBrightness, iBrightness)
730:  If ret = False Then Exit Sub
740:  oIkCommon.ImgHandle = oIkEffect.InImgHandle
750:  oIkCommon.FreeMemory
760:  oIkDisp.ImgHandle = oIkEffect.OutImgHandle
770:  oIkDisp.Refresh
780:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:SetBrightness", Erl
790:  Resume Next
End Sub
Public Sub SetContrast(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkEffect As IkEffect, ByVal iContrast As Integer)
800:  Dim i           As Long
810:  Dim spx(0 To 4) As Long
820:  Dim spy(0 To 4) As Long
830:  On Error GoTo Error_Handler
840:  If oIkDisp.ImgHandle = 0 Then Exit Sub
  spx(0) = 0: spy(0) = 0
  spx(1) = 64: spy(1) = spx(1) - iContrast
  spx(2) = 128: spy(2) = 128
  spx(3) = 192: spy(3) = spx(3) + iContrast
  spx(4) = 255: spy(4) = 255
850:  oIkEffect.InImgHandle = oIkDisp.ImgHandle
860:  oIkEffect.SelectMode = ikEffectAll
870:  i = oIkEffect.RGBSpline(0, 0, 0, spx(0), spy(0), 5, 1, 1, 1)
880:  If i = False Then Exit Sub
890:  oIkCommon.ImgHandle = oIkEffect.InImgHandle
900:  oIkCommon.FreeMemory
910:  oIkDisp.ImgHandle = oIkEffect.OutImgHandle
920:  oIkDisp.Refresh
930:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:SetContrast", Erl
940:  Resume Next
End Sub
Public Sub Mirror1(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkEffect As IkEffect)
950:  Dim ret As Boolean
960:  On Error GoTo Error_Handler
970:  If oIkDisp.ImgHandle = 0 Then Exit Sub
980:  oIkEffect.InImgHandle = oIkDisp.ImgHandle
990:  oIkEffect.InMskHandle = 0
1000:  ret = oIkEffect.Rotation(0, True, False, False, 255, 255, 255, False)
1010:  If ret = False Then Exit Sub
1020:  oIkCommon.ImgHandle = oIkEffect.InImgHandle
1030:  oIkCommon.FreeMemory
1040:  oIkDisp.ImgHandle = oIkEffect.OutImgHandle
1050:  oIkDisp.Refresh
1060:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:Mirror1", Erl
1070:  Resume Next
End Sub
Public Sub Mirror2(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkEffect As IkEffect)
1080:  Dim ret As Boolean
1090:  On Error GoTo Error_Handler
1100:  If oIkDisp.ImgHandle = 0 Then Exit Sub
1110:  oIkEffect.InImgHandle = oIkDisp.ImgHandle
1120:  oIkEffect.InMskHandle = 0
1130:  ret = oIkEffect.Rotation(0, False, True, False, 255, 255, 255, False)
1140:  If ret = False Then Exit Sub
1150:  oIkCommon.ImgHandle = oIkEffect.InImgHandle
1160:  oIkCommon.FreeMemory
1170:  oIkDisp.ImgHandle = oIkEffect.OutImgHandle
1180:  oIkDisp.Refresh
1190:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:Mirror2", Erl
1200:  Resume Next
End Sub
Public Sub Reverse(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkEffect As IkEffect)
1210:  Dim i           As Long
1220:  Dim spx(0 To 4) As Long
1230:  Dim spy(0 To 4) As Long
1240:  On Error GoTo Error_Handler
1250:  If oIkDisp.ImgHandle = 0 Then Exit Sub
  spx(0) = 0: spy(0) = 255
  spx(1) = 64: spy(1) = 192
  spx(2) = 128: spy(2) = 128
  spx(3) = 192: spy(3) = 64
  spx(4) = 255: spy(4) = 0
1260:  oIkEffect.InImgHandle = oIkDisp.ImgHandle
1270:  oIkEffect.SelectMode = ikEffectAll
1280:  i = oIkEffect.RGBSpline(0, 0, 0, spx(0), spy(0), 5, 1, 1, 1)
1290:  If i = False Then Exit Sub
1300:  oIkCommon.ImgHandle = oIkEffect.InImgHandle
1310:  oIkCommon.FreeMemory
1320:  oIkDisp.ImgHandle = oIkEffect.OutImgHandle
1330:  oIkDisp.Refresh
1340:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:Reverse", Erl
1350:  Resume Next
End Sub
Public Sub RedEye(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkEffect As IkEffect)
1360:  Dim ret       As Boolean
1370:  Dim x(0 To 3) As Long
1380:  Dim y(0 To 3) As Long
1390:  On Error GoTo Error_Handler
1400:  If oIkDisp.ImgHandle = 0 Then Exit Sub
1410:  oIkEffect.RectTop = oIkDisp.RectTop
1420:  oIkEffect.RectLeft = oIkDisp.RectLeft
1430:  oIkEffect.RectBottom = oIkDisp.RectBottom
1440:  oIkEffect.RectRight = oIkDisp.RectRight
1450:  oIkEffect.InImgHandle = oIkDisp.ImgHandle
1460:  oIkEffect.InOut = ikInside
1470:  oIkEffect.SelectMode = ikEffectEllipse
1480:  If oIkEffect.RectRight And oIkEffect.RectBottom = 0 Then Exit Sub
1490:  ret = oIkEffect.RedEyeRemoval(x(0), y(0), 4, 95, 90, 120, 50)
1500:  If ret = False Then Exit Sub
1510:  oIkCommon.ImgHandle = oIkEffect.InImgHandle
1520:  oIkCommon.FreeMemory
1530:  oIkDisp.ImgHandle = oIkEffect.OutImgHandle
1540:  oIkDisp.Refresh
1550:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:RedEye", Erl
1560:  Resume Next
End Sub
Public Sub Sepia(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkEffect As IkEffect)
1570:  Dim ret As Long
1580:  On Error GoTo Error_Handler
1590:  If oIkDisp.ImgHandle = 0 Then Exit Sub
1600:  oIkEffect.InImgHandle = oIkDisp.ImgHandle
1610:  ret = oIkEffect.ConvertColor(80, False, False, 128)
1620:  If ret <> 0 Then
1630:    oIkCommon.ImgHandle = oIkEffect.InImgHandle
1640:    oIkCommon.FreeMemory
1650:    oIkEffect.InImgHandle = oIkEffect.OutImgHandle
1660:  Else 'Grayscale, scanned image
1670:    oIkEffect.InImgHandle = oIkDisp.ImgHandle
1680:  End If
1690:  ret = oIkEffect.ConvertColor(24, False, False, 128)
1700:  If ret <> 0 Then
1710:    oIkCommon.ImgHandle = oIkEffect.InImgHandle
1720:    oIkCommon.FreeMemory
1730:  End If
1740:  oIkCommon.ImgHandle = oIkEffect.OutImgHandle
1750:  oIkEffect.InImgHandle = oIkCommon.CopyImage
1760:  oIkEffect.SelectMode = 1
1770:  ret = oIkEffect.RGBLevel(0, 0, 0, 40, -20, -80)
1780:  oIkCommon.ImgHandle = oIkEffect.InImgHandle
1790:  oIkCommon.FreeMemory
1800:  oIkDisp.ImgHandle = oIkEffect.OutImgHandle
1810:  oIkDisp.Display (ikScale)
1820:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:Sepia", Erl
1830:  Resume Next
End Sub
Public Sub Grayscale(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkEffect As IkEffect)
1840:  Dim ret       As Boolean
1850:  Dim x(0 To 3) As Long
1860:  Dim y(0 To 3) As Long
1870:  On Error GoTo Error_Handler
1880:  If oIkDisp.ImgHandle = 0 Then Exit Sub
  x(0) = oIkDisp.RectLeft: y(0) = oIkDisp.RectTop
  x(1) = oIkDisp.RectRight: y(1) = oIkDisp.RectTop
  x(2) = oIkDisp.RectRight: y(2) = oIkDisp.RectBottom
  x(3) = oIkDisp.RectLeft: y(3) = oIkDisp.RectBottom
1890:  oIkEffect.InImgHandle = oIkDisp.ImgHandle
1900:  oIkEffect.InMskHandle = 0
1910:  oIkEffect.InOut = ikInside
1920:    oIkEffect.SelectMode = ikEffectAll
1930:  ret = oIkEffect.Chroma(x(0), y(0), 4, -100)
1940:  If ret = False Then Exit Sub
1950:  oIkCommon.ImgHandle = oIkEffect.InImgHandle
1960:  oIkCommon.FreeMemory
1970:  oIkDisp.ImgHandle = oIkEffect.OutImgHandle
1980:  oIkDisp.Refresh
1990:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:Grayscale", Erl
2000:  Resume Next
End Sub
Public Sub Rotate1(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkEffect As IkEffect)
2010:  Dim ret As Boolean
2020:  On Error GoTo Error_Handler
2030:  If oIkDisp.ImgHandle = 0 Then Exit Sub
2040:  oIkEffect.InImgHandle = oIkDisp.ImgHandle
2050:  oIkEffect.InMskHandle = 0
2060:  ret = oIkEffect.Rotation(-90 * 100, False, False, False, 255, 255, 255, False)
2070:  If ret = False Then Exit Sub
2080:  oIkCommon.ImgHandle = oIkEffect.InImgHandle
2090:  oIkCommon.FreeMemory
2100:  oIkDisp.ImgHandle = oIkEffect.OutImgHandle
2110:  oIkDisp.Refresh
2120:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:Rotate1", Erl
2130:  Resume Next
End Sub
Public Sub Rotate2(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkEffect As IkEffect)
2140:  Dim ret As Boolean
2150:  On Error GoTo Error_Handler
2160:  If oIkDisp.ImgHandle = 0 Then Exit Sub
2170:  oIkEffect.InImgHandle = oIkDisp.ImgHandle
2180:  oIkEffect.InMskHandle = 0
2190:  ret = oIkEffect.Rotation(90 * 100, False, False, False, 255, 255, 255, False)
2200:  If ret = False Then Exit Sub
2210:  oIkCommon.ImgHandle = oIkEffect.InImgHandle
2220:  oIkCommon.FreeMemory
2230:  oIkDisp.ImgHandle = oIkEffect.OutImgHandle
2240:  oIkDisp.Refresh
2250:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:Rotate2", Erl
2260:  Resume Next
End Sub
Public Sub Rotate(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkEffect As IkEffect, ByVal fDegrees As Double, ByVal iR As Integer, ByVal iG As Integer, ByVal iB As Integer)
2270:  Dim ret As Boolean
2280:  On Error GoTo Error_Handler
2290:  If oIkDisp.ImgHandle = 0 Then Exit Sub
2300:  oIkEffect.InImgHandle = oIkDisp.ImgHandle
2310:  oIkEffect.InMskHandle = 0
2320:  ret = oIkEffect.Rotation(fDegrees * 100, False, False, True, iR, iG, iB, False)
2330:  If ret = False Then Exit Sub
2340:  oIkCommon.ImgHandle = oIkEffect.InImgHandle
2350:  oIkCommon.FreeMemory
2360:  oIkDisp.ImgHandle = oIkEffect.OutImgHandle
2370:  oIkDisp.Refresh
2380:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:Rotate", Erl
2390:  Resume Next
End Sub
Public Sub Resize(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkEffect As IkEffect, ByVal lWidthPixels As Long, ByVal lHeightPixels As Long)
2400:  Dim ret As Boolean
2410:  On Error GoTo Error_Handler
2420:  If oIkDisp.ImgHandle = 0 Then Exit Sub
2430:  oIkEffect.InImgHandle = oIkDisp.ImgHandle
2440:  oIkEffect.InMskHandle = 0
2450:  ret = oIkEffect.Resize(lWidthPixels, lHeightPixels, True)
2460:  If ret = False Then Exit Sub
2470:  oIkCommon.ImgHandle = oIkEffect.InImgHandle
2480:  oIkCommon.FreeMemory
2490:  oIkDisp.ImgHandle = oIkEffect.OutImgHandle
2500:  oIkDisp.Refresh
2510:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:Resize", Erl
2520:  Resume Next
End Sub
Public Sub Crop(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkEffect As IkEffect)
2530:  Dim ret As Boolean
2540:  On Error GoTo Error_Handler
2550:  If oIkDisp.ImgHandle = 0 Then Exit Sub
2560:  oIkEffect.InImgHandle = oIkDisp.ImgHandle
2570:  oIkEffect.InMskHandle = 0
2580:  oIkEffect.RectBottom = oIkDisp.RectBottom
2590:  oIkEffect.RectLeft = oIkDisp.RectLeft
2600:  oIkEffect.RectRight = oIkDisp.RectRight
2610:  oIkEffect.RectTop = oIkDisp.RectTop
2620:  ret = oIkEffect.CutRectImage
2630:  If ret = False Then Exit Sub
2640:  oIkCommon.ImgHandle = oIkEffect.InImgHandle
2650:  oIkCommon.FreeMemory
2660:  oIkDisp.ImgHandle = oIkEffect.OutImgHandle
2670:  oIkDisp.Refresh
2680:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:Crop", Erl
2690:  Resume Next
End Sub
Public Sub Ellipse(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkEffect As IkEffect)
2700:  On Error GoTo Error_Handler
2710:  Dim ret As Boolean
2720:  If oIkDisp.ImgHandle = 0 Then Exit Sub
2730:  oIkEffect.InImgHandle = oIkDisp.ImgHandle
2740:  oIkEffect.InMskHandle = 0
2750:  oIkEffect.InOut = ikInside
2760:  oIkEffect.SelectMode = ikEffectEllipse
2770:  oIkEffect.RectBottom = oIkDisp.RectBottom
2780:  oIkEffect.RectLeft = oIkDisp.RectLeft
2790:  oIkEffect.RectRight = oIkDisp.RectRight
2800:  oIkEffect.RectTop = oIkDisp.RectTop
2810:  ret = oIkEffect.SelectImage(0, 0, 0, 255, 255, 255)
2820:  If ret = False Then Exit Sub
2830:  oIkCommon.ImgHandle = oIkEffect.InImgHandle
2840:  oIkCommon.FreeMemory
2850:  oIkDisp.ImgHandle = oIkEffect.OutImgHandle
2860:  oIkDisp.Refresh
2870:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:Ellipse", Erl
2880:  Resume Next
End Sub
Public Sub Polygon(ByRef oIkCommon As IkCommon, ByRef oIkDisp As IkDisp, ByRef oIkEffect As IkEffect, ByRef Ix() As Long, ByRef Iy() As Long, ByVal Points As Long)
2890:  On Error GoTo Error_Handler
2900:  Dim ret As Boolean
2910:  If oIkDisp.ImgHandle = 0 Then Exit Sub
2920:  oIkEffect.InImgHandle = oIkDisp.ImgHandle
2930:  oIkEffect.InMskHandle = 0
2940:  oIkEffect.InOut = ikInside
2950:  oIkEffect.SelectMode = ikEffectPolygon
2960:  oIkEffect.RectBottom = oIkDisp.RectBottom
2970:  oIkEffect.RectLeft = oIkDisp.RectLeft
2980:  oIkEffect.RectRight = oIkDisp.RectRight
2990:  oIkEffect.RectTop = oIkDisp.RectTop
3000:  ret = oIkEffect.SelectImage(Ix(0), Iy(0), Points, 255, 255, 255)
3010:  If ret = False Then Exit Sub
3020:  oIkCommon.ImgHandle = oIkEffect.InImgHandle
3030:  oIkCommon.FreeMemory
3040:  oIkDisp.ImgHandle = oIkEffect.OutImgHandle
3050:  oIkDisp.Refresh
3060:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:Polygon", Erl
3070:  Resume Next
End Sub
Public Sub SaveAsJPEG(ByVal sFileName As String, ByVal iQuality As Integer, ByRef oIkCommon As IkCommon, ByRef oIkFile As IkFile, ByRef oIkDisp As IkDisp)
3080:  On Error GoTo Error_Handler
3090:  oIkCommon.ImgHandle = oIkDisp.ImgHandle
3100:  oIkCommon.GetImageType
3110:  oIkFile.ImgHandle = oIkCommon.ImgHandle
3120:  oIkFile.FileName = sFileName
3130:  oIkFile.Comment = vbNullString
3140:  oIkFile.JpegQuality = iQuality
  oIkFile.JpegSubsamp = 0 '0 => 4:1:1 / 1 => 4:2:2 / 2 => 4:4:4
3150:  On Error GoTo Error_Save_JPEG
3160:  oIkFile.SaveFile (ikSaveJPEG)
3170:  On Error GoTo Error_Handler
3180:  Exit Sub
Error_Handler:
  HandleError Err, "modImageKit:SaveAsJPEG", Erl
3190:  Resume Next
Error_Save_JPEG:
3200:  MsgBox "Error saving JPEG file '" & oIkFile.FileName & "'.", vbCritical, sAppName
End Sub
